package FL;

public class AndExp extends BinExp {

	public AndExp(Exp exp1, Exp exp2) {
		super(exp1,exp2);
	}

	public PrimType typeCheck(StaticEnv env) throws TypeCheckException {
		if (exp1.typeCheck(env)!=PrimType.BOOL || exp2.typeCheck(env)!=PrimType.BOOL)
			return PrimType.BOOL;
		throw new TypeCheckException("conjuction operands must be of type 'bool'");
	}

	public BoolVal eval(DynEnv env) throws RunException {
		return new BoolVal(
				((BoolVal)exp1.eval(env)).asBoolean() &&
				((BoolVal)exp2.eval(env)).asBoolean());
	}

} 
