package FL;

public class ConstDec implements Dec{

	private Id id;
	private PrimType type;
	private Exp exp; 

	public ConstDec(Id id,PrimType type,Exp exp){
		this.id=id;
		this.type=type;
		this.exp=exp;
	}

	public void typeCheck(StaticEnv env) throws TypeCheckException {
		if (exp.typeCheck(env)!=type) 
			throw new TypeCheckException("type mismatch in constant declaration");
		env.update(id,type);
	}

	public void eval(DynEnv env) throws RunException {
		env.update(id,exp.eval(env)); 
	}

} 
