package FL;

public class EqExp extends BinExp {

	public EqExp(Exp exp1,Exp exp2) {
		super(exp1,exp2);
	}

	public PrimType typeCheck(StaticEnv env) throws TypeCheckException {
		if (exp1.typeCheck(env)==exp2.typeCheck(env))
			return PrimType.BOOL;
		throw new TypeCheckException("equality test operands must have the same type");
	}

	public BoolVal eval(DynEnv env)throws RunException{
		return new BoolVal( exp1.eval(env).equals(exp2.eval(env)) );
	}

} 
