package FL;

import java.util.*;

public class ExpsImpl implements Exps {

	private List<Exp> exps = new ArrayList<Exp>();

	public ExpsImpl() {}

	public ExpsImpl(Exp exp) {
		add(exp);
	}

	public void add(Exp exp) {
		exps.add(exp);
	}

	public List<PrimType> typeCheck(StaticEnv env)throws TypeCheckException{
		ArrayList<PrimType> types=new ArrayList<PrimType>();
		for(Exp e : exps)
			types.add(e.typeCheck(env));
		return types;
	}

	public Iterable<PrimVal> eval(DynEnv env)throws RunException{
		ArrayList<PrimVal> values=new ArrayList<PrimVal>();
		for(Exp e : exps)
			values.add(e.eval(env));
		return values;
	}

} 
