package FL;

public class FunCallExp implements Exp{

	private Id id;
	private Exps exps;
 
	public FunCallExp(Id id,Exps exps){
		this.id=id;
		this.exps=exps;
	}

	public PrimType typeCheck(StaticEnv env) throws TypeCheckException{
		Type idType=env.apply(id);
		if (idType==null) 
			throw new TypeCheckException("undeclared identifier "+id);
		if (!(idType instanceof FunType)) 
			throw new TypeCheckException(id+" must be a function");
		FunType funType=(FunType) idType;
		if (!exps.typeCheck(env).equals(funType.argsType()))
			throw new TypeCheckException("parameter types do not match");    
		return funType.retType();
	}

	public PrimVal eval(DynEnv env) throws RunException{
		FunVal f = (FunVal) env.apply(id);
		return f.apply(exps.eval(env));
	}

} 
