package FL;

public class FunDec implements Dec{
 
	private Id id;
	private Params params;
	private PrimType type;
	private Exp exp; 

	public FunDec(Id id,Params params,PrimType type,Exp exp){
		this.id=id;
		this.params=params;
		this.type=type;
		this.exp=exp;
	}

	public void typeCheck(StaticEnv env) throws TypeCheckException{
		StaticEnv env1=env.clone();
		FunType ft=new FunTypeImpl(params.types(), type);
		env1.update(id, ft); // to allow recursion
		params.typeCheck(env1);
		if (exp.typeCheck(env1)!=type) 
			throw new TypeCheckException("type mismatch in function declaration");
		env.update(id, ft);
	}

	public void eval(DynEnv env) throws RunException {
		DynEnv env1=env.clone();
		FunVal f=new FunVal(params.ids(), exp, env1);
		env1.update(id, f); // to allow recursion
		env.update(id, f);
	}

} 
