package FL;

public class IdExp implements Exp {
 
	private Id id;
 
	public IdExp(Id id){
		this.id=id;
	}

	public PrimType typeCheck(StaticEnv env)throws TypeCheckException{
		Type idType=env.apply(id);
		if (idType==null) 
			throw new TypeCheckException("undeclared identifier "+id);
		else if (!(idType instanceof PrimType)) 
			throw new TypeCheckException("expressions must have a primitive type");
		return (PrimType) idType;
	}

	public PrimVal eval(DynEnv env) throws RunException{
		return (PrimVal) env.apply(id);
	}

} 
