package FL;

public class IfExp implements Exp{
 
	private Exp ifExp,thenExp,elseExp;

	public IfExp(Exp ifExp,Exp thenExp,Exp elseExp){
		this.ifExp=ifExp;
		this.thenExp=thenExp;
		this.elseExp=elseExp;
	}

	public PrimType typeCheck(StaticEnv env)throws TypeCheckException{
		PrimType thenType=thenExp.typeCheck(env);
		PrimType elseType=elseExp.typeCheck(env);
		if (ifExp.typeCheck(env)!=PrimType.BOOL || thenType!=elseType) 
			throw new TypeCheckException("type mismatch in if-expression");
		return thenType;
	}

	public PrimVal eval(DynEnv env) throws RunException{
		return ((BoolVal)ifExp.eval(env)).asBoolean() ?
					thenExp.eval(env) :
					elseExp.eval(env);
	}

} 
