package FL;

import java.io.*;

public class Interpreter{

	private static void interpret(boolean interactiveMode, Scanner scanner) {
		Parser parser=new Parser(scanner);
		try {
			Prog p = parser.parseProg(interactiveMode);
			PrimType type=p.typeCheck();
			PrimVal value=p.eval();
			System.out.println(value+" : "+type);
		} catch(IOException e) {
			System.out.println("I/O error while parsing: "+e.getMessage());
		} catch(Exception e) {
			System.out.println(e.getMessage());
		}
	}

	public static void main(String[] args) {
		System.out.println("FL interpreter");
		for (String arg : args)
			try {
				System.out.println("   Loading file "+arg);
				interpret(false, new Scanner(new BufferedReader(new FileReader(arg))));
			} catch(IOException e) {
				System.out.println("I/O error while reading file: "+arg);
			}
		System.out.println("   You are now in interactive mode.");
		System.out.println("   Use ';' to end programs; extra characters will be ignored.");
		System.out.println("   Enter ^C to quit.");
		for(;;) {
			Reader reader=new BufferedReader(new InputStreamReader(System.in));
			System.out.print("? ");
			interpret(true, new Scanner(reader));
		}
	}

}
