package FL;

public class OrExp extends BinExp {

	public OrExp(Exp exp1,Exp exp2) {
		super(exp1,exp2);
	}

	public PrimType typeCheck(StaticEnv env) throws TypeCheckException {
		if (exp1.typeCheck(env)!=PrimType.BOOL || exp2.typeCheck(env)!=PrimType.BOOL)
			throw new TypeCheckException("disjunction operands must be of type 'bool'");
		return PrimType.BOOL;
	}

	public BoolVal eval(DynEnv env) throws RunException {
		return new BoolVal(
				((BoolVal)exp1.eval(env)).asBoolean() || 
				((BoolVal)exp2.eval(env)).asBoolean());
	}

} 
