package FL;

import java.util.*;

public class ParamsImpl implements Params{

	private List<Param> params = new ArrayList<Param>();

	public ParamsImpl() {}

	public ParamsImpl(Param par){
		add(par);
	}

	public void add(Param par){
		params.add(par);
	}

	public List<PrimType> types() {
		ArrayList<PrimType> types=new ArrayList<PrimType>();
		for(Param p : params)
			types.add(p.type());
		return types; 
	}

	public Iterable<Id> ids() {
		ArrayList<Id> ids=new ArrayList<Id>();
		for(Param p : params)
			ids.add(p.id());
		return ids; 
	}

	public void typeCheck(StaticEnv env) throws TypeCheckException {
		Set<Id> usedIds = new HashSet<Id>();
		for(Param p: params) {
			Id id = p.id();
			if ( usedIds.contains(id) )
			     throw new TypeCheckException("parameter names must be distinct"); 
			usedIds.add(id);
			env.update(id, p.type());
		}
	}
 
} 
