package FL;

public class SumExp extends BinExp {

	public SumExp(Exp exp1,Exp exp2){
		super(exp1,exp2);
	}

	public PrimType typeCheck(StaticEnv env) throws TypeCheckException{
		if (exp1.typeCheck(env)!=PrimType.INT || exp2.typeCheck(env)!=PrimType.INT)
			throw new TypeCheckException("sum operands must be of type 'int'");
		return PrimType.INT;
	}

	public IntVal eval(DynEnv env)throws RunException{
		return new IntVal(
				((IntVal)exp1.eval(env)).asInt() +
				((IntVal)exp2.eval(env)).asInt());
	}

} 
